	opt	6809
	opt	cd

;	org	$1000
;start	
	orcc	#$50
	clr		$71		;cold reset

	jsr	fcls	
;****************************	
; CLEAR THE SCREEN
;****************************	
	ldd	#$8080
	ldx	#$400
clrsc	std	,x++
	cmpx	#$1000		1000
	blo	clrsc


;****************************	
; SG12	
;****************************	
	lda	#$8
	sta	$ff22
	sta	$ffc5
;****************************	
	
	jsr	$5800		;fire up dipole (music)


lp1	lda	$ff03
	bpl	lp1
	lda	$ff02
	dec	cnt
	bne	lp1
	lda	#2		(2)
	sta	cnt

ptr	lda	flp
	beq	reset
	sta	fade
	jsr	tplot
	inc	ptr+2	
	jmp	lp1

reset	ldd	#flp	
	std	ptr+1

	lda	,y
	cmpa	#$ff
	beq	dun
	sty	tplot+2
	jmp	lp1


dun	jmp	$1600		;jump to FIRE



;****************************	
; PLOT THE TEXT 
;****************************	
tplot	ldy	#text
	ldx	#$980		900
plotit	ldb	,y+
	beq	out
	decb
	subb	#$40
	aslb	
	clra	
	addd	#ctab
	ldu	#0
	ldu	d,u
	jsr	cplot
	leax	4,x	
	jmp	plotit
out	rts	
;****************************	
; CHAR PLOT ROUTINE
; X=SCREEN POSITION
; U=POINTER TO CHAR
;****************************	


cplot  	ldd	,u
	ora	fade
	orb	fade
	cmpd	#$8f8f
	bne	p1
	ldd	#$8080
p1	std	,x

	ldd	2,u
	ora	fade
	orb	fade
	cmpd	#$8f8f
	bne	p2
	ldd	#$8080
p2	std	2,x

	ldd	4,u
	ora	fade
	orb	fade
	cmpd	#$8f8f
	bne	p3
	ldd	#$8080
p3	std	32,x

	ldd	6,u
	ora	fade
	orb	fade
	cmpd	#$8f8f
	bne	p4
	ldd	#$8080
p4	std	34,x

	ldd	8,u
	ora	fade
	orb	fade
	cmpd	#$8f8f
	bne	p5
	ldd	#$8080
p5	std	64,x

	ldd	10,u
	ora	fade
	orb	fade
	cmpd	#$8f8f
	bne	p6
	ldd	#$8080
p6	std	66,x

	ldd	12,u
	ora	fade
	orb	fade
	cmpd	#$8f8f
	bne	p7
	ldd	#$8080
p7	std	96,x

	ldd	14,u
	ora	fade
	orb	fade
	cmpd	#$8f8f
	bne	p8
	ldd	#$8080
p8	std	98,x

	ldd	16,u
	ora	fade
	orb	fade
	cmpd	#$8f8f
	bne	p9
	ldd	#$8080
p9	std	128,x

	ldd	18,u
	ora	fade
	orb	fade
	cmpd	#$8f8f
	bne	p10
	ldd	#$8080
p10	std	130,x

	rts



;***************************
; funky cls
;***************************
fcls
	ldx	#$400
	ldu	#$600

waitr	lda	$ff03
	bpl	waitr
	lda	$ff02
w2	lda	$ff03
	bpl	w2
	lda	$ff02

	ldd	#$8080
tline	std	,x++
	std	,--u
	cmpx	#$500
	bne	waitr
	rts


	align	$100

text	fcc	"[[OVER"
	fcb	0
	fcc	"ZO[YEARS"
	fcb	0
	fcc	"[[HAVE"
	fcb	0
	fcc	"[PASSED"
	fcb	0
	fcc	"[[[[[[["
	fcb	0
	fcc	"[SINCE"
	fcb	0
	fcc	"[[[MY"
	fcb	0
	fcc	"[[LAST"
	fcb	0
	fcc	"[PROPER"
	fcb	0
	fcc	"[[MEGA"
	fcb	0	
	fcc	"[[DEMO"
	fcb	0	
	fcc	"[[[[[[[["
	fcb	0
	fcc	"WELCOME"
	fcb	0
	fcc	"[[[TO"
	fcb	0
	fcc	"[[TANDY"
	fcb	0
	fcc	"ASSEMBLY"
	fcb	0	
	fcc	"[[[[[[[["
	fcb	0	
	fcc	"[[[GO"
	fcb	0
	fcc	"MAD[COCO"
	fcb	0
	fcc	"[[[[[[[["
	fcb	0	
	fcc	"[[[[[[[["
	fcb	0	
	fdb	$ff,$ff	

	align	$100
	
;****************************	
;A B C D E F G H
;****************************
chara	fcb	$80,$8f,$8f,$80
	fcb	$80,$8a,$85,$80
	fcb	$85,$8f,$8f,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a

charb	fcb	$80,$8f,$8f,$80
	fcb	$80,$8a,$85,$80
	fcb	$85,$8f,$8f,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8f,$8f,$8a

charc	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$80,$8a
	fcb	$85,$8a,$80,$80
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8f,$8f,$8a

chard	fcb	$85,$8f,$8f,$80
	fcb	$85,$80,$80,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8f,$8f,$80

chare	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$80,$80
	fcb	$85,$8f,$8f,$8a
	fcb	$85,$8a,$80,$80
	fcb	$85,$8f,$8f,$8a

charf	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$80,$80
	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$80,$80
	fcb	$85,$80,$80,$80

charg	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$80,$80
	fcb	$85,$8a,$85,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8f,$8f,$8a

charh	fcb	$85,$80,$80,$8a
	fcb	$85,$80,$80,$8a
	fcb	$85,$8f,$8f,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a

;****************************	
;I J K L M N O P
;****************************
chari 	fcb	$80,$85,$80,$80
	fcb	$80,$85,$80,$80
	fcb	$80,$85,$8a,$80
	fcb	$80,$85,$8a,$80
	fcb	$80,$85,$8a,$80

charj	fcb	$80,$80,$85,$80
	fcb	$80,$80,$85,$80
	fcb	$80,$80,$85,$8a
	fcb	$85,$80,$85,$8a
	fcb	$85,$8f,$8f,$8a

chark	fcb	$85,$80,$80,$80
	fcb	$85,$80,$85,$80
	fcb	$85,$8f,$8f,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a

charl	fcb	$85,$80,$80,$80
	fcb	$85,$80,$80,$80
	fcb	$85,$8a,$80,$80
	fcb	$85,$8a,$80,$80
	fcb	$85,$8f,$8f,$8a

charm	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$8a,$8a
	fcb	$85,$8a,$8a,$8a
	fcb	$85,$8a,$8a,$8a
	fcb	$85,$8a,$8a,$8a

charn	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$80,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a

charo	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$85,$8a
	fcb	$85,$80,$80,$8a
	fcb	$85,$80,$80,$8a
	fcb	$85,$8f,$8f,$8a

charp	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$80,$8a
	fcb	$85,$8f,$8f,$8a
	fcb	$85,$8a,$80,$80
	fcb	$85,$8a,$80,$80
	
;****************************	
;Q R S T U V W X
;****************************
charq	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$80,$8a
	fcb	$85,$80,$80,$8a
	fcb	$85,$80,$8f,$8a
	fcb	$85,$8f,$8f,$8a

charr	fcb	$85,$8f,$8f,$80
	fcb	$85,$80,$85,$80
	fcb	$85,$8f,$8f,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a

chars	fcb	$85,$8f,$8f,$8a
	fcb	$85,$80,$80,$80
	fcb	$85,$8f,$8f,$8a
	fcb	$80,$80,$85,$8a
	fcb	$85,$8f,$8f,$8a

chart	fcb	$85,$8f,$8f,$8a
	fcb	$80,$85,$80,$80
	fcb	$80,$85,$8a,$80
	fcb	$80,$85,$8a,$80
	fcb	$80,$85,$8a,$80

charu	fcb	$85,$80,$80,$8a
	fcb	$85,$80,$80,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8f,$8f,$8a

charv	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a
	fcb	$80,$8a,$85,$80
	fcb	$80,$8f,$8f,$80

charw	fcb	$85,$80,$8a,$8a
	fcb	$85,$80,$8a,$8a
	fcb	$85,$8a,$8a,$8a
	fcb	$85,$8a,$8a,$8a
	fcb	$85,$8f,$8f,$8a

charx	fcb	$85,$80,$80,$8a
	fcb	$85,$80,$80,$8a
	fcb	$80,$8f,$8f,$80
	fcb	$85,$8a,$80,$8a
	fcb	$85,$8a,$80,$8a

;****************************	
;Y Z
;****************************
chary	fcb	$85,$80,$80,$8a
	fcb	$85,$80,$80,$8a
	fcb	$85,$8f,$8f,$8a
	fcb	$80,$85,$8a,$80
	fcb	$80,$85,$8a,$80

charz	fcb	$85,$8f,$8f,$8a
	fcb	$80,$80,$80,$8a
	fcb	$85,$8f,$8f,$8a
	fcb	$85,$8a,$80,$80
	fcb	$85,$8f,$8f,$8a
;****************************
;SPACEFILL
;****************************
space	fcb	$80,$80,$80,$80
	fcb	$80,$80,$80,$80
	fcb	$80,$80,$80,$80
	fcb	$80,$80,$80,$80
	fcb	$80,$80,$80,$80



;****************************

ctab	fdb	chara
	fdb	charb
	fdb	charc
	fdb	chard
	fdb	chare
	fdb	charf
	fdb	charg
	fdb	charh
	fdb	chari
	fdb	charj
	fdb	chark
	fdb	charl
	fdb	charm
	fdb	charn
	fdb	charo
	fdb	charp
	fdb	charq
	fdb	charr
	fdb	chars
	fdb	chart
	fdb	charu
	fdb	charv
	fdb	charw
	fdb	charx
	fdb	chary
	fdb	charz
	fdb	space
;****************************	

fade	fcb	$f
cnt	fcb	2



flp		equ		*

black1		equ		$0f
green1		equ		$80
yellow1		equ		$90
blue1		equ		$a0
red1		equ		$b0
white1		equ		$c0
cyan1		equ		$d0
magenta1	equ		$e0
orange1		equ		$f0


		fill	black1,20


		fill	red1,2
		fill	orange1,3
		fill	yellow1,4
		fill	white1,20
		fill	yellow1,3
		fill	orange1,2
		fill	red1,1


		fill	black1,20
	

stopfill	fcb	$0



;		end	start