;***********************************
; VECTOR MASHUP BY THE INVISIBLE MAN
; (AKA SIMON JONASSEN)
; (c) 2017 - free for all 
; use as you see fit 
; give credit where it's due
;
; signed MUL by SIXXIE, tweaked
; by the invisible man (SBCA #0
; INSTEAD OF ADDD #1)
;
; pmode4 line plot by SORCHARD 
; (tweaked by INVISIBLE MAN
; IMMEDIATE LOAD FOR PIXEL)
;
; (tweaked even more by SIXXIE
; using various cases for shallow)
;
;***********************************
;		org 	$4800

		opt	6809
		opt	cd

;START
;		orcc 	#$50


	
 		jsr	setup2

		opt	cc
		opt	ct

;**********************************
; process endpoints of figure
;
; eg. apply z,x,y rotations
; of given endpoint
;**********************************
main
		lda	$ff02
		
wvs2		lda	$ff03		;go wait for an vsync
		bpl	wvs2
		dec	counter2
		bne	okie

shit		jmp 	TV
		

okie		lda	flip+2
		eora	#1		;flips display buffer
		sta	flip+2
	
		lda	scraddr
		eora	#$20		;swap plot address ($1000/$3000)
		sta	scraddr


flip		sta	$ffce		;swap display buffer ($1000/$3000)
;**********************************
; UPDATE X,Y,Z ANGLES
;**********************************
		lda	xangle+1
		adda	#6		;2
		sta	xangle+1
		lda	yangle+1
		adda	#1		;3
		sta	yangle+1
		lda	zangle+1
		adda	#6		;3
		sta	zangle+1

		opt	cc
;**********************************
;semi unrolled delete
;**********************************

delete		ldd	#$0720		;7 loops of 32 (abx)
		ldu	#$0
		ldx	scraddr	;screen address (varies by frame)
		leax	$549,x		;area to plot/delete in

again		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x

		abx

		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x

		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx

		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx



		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x

		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x

		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx

		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx
		stu	,x
		stu	2,x
		stu	4,x
		stu	6,x
		stu	8,x
		stu	10,x
		stu	12,x
		abx

		deca
		lbne	again

;**********************************
; Process the vectors
;**********************************
dolines		ldu	#figure		;object
		ldx	#newpoints	;list of rotated points
figloop		ldd	,u++		;grab x/y
		bne	roto		;end of points - go plot lines

;**********************************
; PLAY CONNECT THE DOTS
; USING THE TABLE OF DOTS AND 
; DESC OF WHICH ONES TO CONNECT
;**********************************
connect		ldu	#vertfig	;point to list of points to connect		
cloop		ldd	,u++		;grab a point descriptor
		lbmi	main		;did we get end of description ? then go back	
		asla			;*2 - word lookup
		aslb		
		ldx	#newpoints	;point to rotated points table
		ldy	a,x		;get the indexed rotated points
		sty	x0y0		;put into the line routine
		ldy	b,x		;change to LDX for dots
		sty	x1y1	

		jmp	line		;JMP/JMP (faster than jsr/rts)


;**********************************
; ROTATE
;**********************************
roto		std	xp
		lda	,u+		;grab z
		sta	zp

;**********************************
; ROTATION ROUTINES
;**********************************
rotate
;**********************************
;rotate about z axis
;
; x' = x*cos (angle) - y*sin (angle)
; y' = x*sin (angle) + y*cos (angle) 
; z' = z
;**********************************
		ldd	xp		;grab x/y
		std	x2

zangle		lda	#0		;angle
		jsr	makerot	

		ldd	x		;save rotated points (x/y) 
		std	xp

;**********************************
; ROTATE AROUND X AXIS
; y' = y*cos (angle) - z*sin (angle)
; z' = y*sin (angle) + z*cos (angle)
; x' = x
;**********************************
		
		lda	zp
		ldb	yp
		std	x2

xangle		lda	#0		;angle to rotate about

		jsr	makerot	

		ldd	x		;save rotated points (z/y)

		sta	zp
		stb	yp
;**********************************
; ROTATE AROUND Y AXIS
; z' = z*cos (angle) - x*sin (angle)
; x' = z*sin (angle) + x*cos (angle)
; y' = y
;**********************************

		lda	xp
		ldb	zp
		std	x2

yangle		lda	#0

		jsr	makerot	

		ldd	x		;save rotated points (z/x)
		sta	xp
		stb	zp

;**********************************
; convert 3d to 2d
;**********************************
c3d2d		ldy	#ztab
		lda	zp		; get 1st value
		lda	a,y
		bmi	F120_5		; if negative, go change sign
		ldb	xp		; get 2nd value (cos)
		bmi	F112_5		; if negative , go change sign 
		mul     		; multiply them
		bra   	F200_5		; out of smul (+ x +)
F120_5		nega          		; change sign of 1st value
		ldb	xp		; get 2nd value (cos)
		bpl	F113_5		; if positive go to different sign
F122_5		negb         		; change sign of 2nd value
		mul          		; multiply them
		bra   	F200_5 		; out of smul ( - x -)
F112_5		negb         		; change sign of 2nd value
F113_5		mul          		; multiply them
		nega 			; negate
		negb 			; result
		sbca	#0		; add any carry to the result


;**********************************
F200_5	
		aslb			;scaling
		rola
		aslb
		rola
		sta	xp
;**********************************
		lda	zp		; get 1st value
		lda	a,y
		bmi	F120_6		; if negative, go change sign
		ldb	yp		; get 2nd value (cos)
		bmi	F112_6		; if negative , go change sign 
		mul     		; multiply them
		bra   	F200_6		; out of smul (+ x +)
F120_6		nega          		; change sign of 1st value
		ldb	yp		; get 2nd value (cos)
		bpl	F113_6		; if positive go to different sign
F122_6		negb         		; change sign of 2nd value
		mul          		; multiply them
		bra   	F200_6 		; out of smul ( - x -)
F112_6		negb         		; change sign of 2nd value
F113_6		mul          		; multiply them
		nega 			; negate
		negb 			; result
		sbca	#0		; add any carry to the result
;**********************************
F200_6		aslb			;scaling
		rola
		aslb	
		rola
		sta	yp
		ldd	xp		;grab new x/y 
;**********************************
; add centers
; A=128
; B=96
;**********************************
		addd	#$8060		;CENTER OF SCREEN
		std	,x++		;stuff into rotated/centered point table
		jmp	figloop		;over again


		opt	cc
;**********************************
; rotation routine sin/cos
; generic for x/y/z depends on
; whats in x2/y2
;**********************************
makerot		sta	sinlook+2	;index into sin/cos
		sta	coslook+2
sinlook		lda	sintab3		;grab sin value
coslook		ldb	costab3		;grab cos value
		std	sinv		;store it for rotates (sin/cos)
;**********************************
; X * cos(angle)
;**********************************
smul		lda	x2		; get 1st value
		bmi	F120		; if negative, go change sign
cos1		ldb	cosv		; get 2nd value (cos)
		bmi	F112		; if negative , go change sign 
		mul     		; multiply them
		bra   	F200		; out of smul (+ x +)
F120		nega          		; change sign of 1st value
cos2		ldb	cosv		; get 2nd value (cos)
		bpl	F113		; if positive go to different sign
F122		negb         		; change sign of 2nd value
		mul          		; multiply them
		bra   	F200 		; out of smul ( - x -)
F112		negb         		; change sign of 2nd value
F113		mul          		; multiply them
		nega 			; negate
		negb 			; result
		sbca	#0		; add any carry to the result (adcb#0)
;**********************************
; cheaper way of /128 (>>7)
;**********************************
F200		aslb			; move bit7 regB	
		rola			; to bit0 regA
		sta	sub+1		; use regA as (regD/128) at destination
;**********************************
; Y * sin(angle)
;**********************************
		lda	y2		; get 1st value
		bmi	F120_1		; if negative, go change sign
sin1		ldb	sinv		; get 2nd value (sin)
		bmi	F112_1 		; if negative , go change sign 
		mul          		; multiply them
		bra	F200_1		; out of smul (+ x +)
F120_1		nega          		; change sign of 1st value
sin2		ldb	sinv		; get 2nd value (sin)
		bpl	F113_1		; if positive go to different sign
F122_1		negb         		; change sign of 2nd value
		mul          		; multiply them
		bra	F200_1 		; out of smul ( - x -)
F112_1		negb         		; change sign of 2nd value
F113_1		mul          		; multiply them
		nega 			; negate
		negb			; result
		sbca	#0		; add any carry to the result
F200_1		aslb			; move bit7 regB	
		rola			; to bit0 regA
;**********************************
; x' = x*cos (angle) - y*sin (angle)
;**********************************
sub		suba	#0		; Y*sin(angle)-X*cos(angle)
		sta	x		; save result
;**********************************
; X * sin(angle)
;**********************************
		lda	x2		; get 1st value
		bmi	F120_2		; if negative, go change sign
		ldb	sinv		; get 2nd value (sin)
		bmi	F112_2 		; if negative , go change sign 
		mul         		; multiply them
		bra	F200_2		; out of smul (+ x +)
F120_2		nega          		; change sign of 1st value
		ldb	sinv		; get 2nd value (sin)
		bpl	F113_2		; if positive go to different sign
F122_2		negb         		; change sign of 2nd value
		mul          		; multiply them
		bra	F200_2 		; out of smul ( - x -)
F112_2		negb         		; change sign of 2nd value
F113_2		mul          		; multiply them
		nega 			; negate
		negb 			; result
		sbca	#0		; add any carry to the result
F200_2		aslb			; move bit7 regB	
		rola			; to bit0 regA
		sta	add+1		; use regA as (regD/128) at destination
;**********************************
; Y * cos(angle)
;**********************************
		lda	y2		; get 1st value
		bmi	F120_3		; if negative, go change sign
		ldb	cosv		; get 2nd value (cos)
		bmi	F112_3 		; if negative , go change sign 
		mul          		; multiply them
		bra	F200_3		; out of smul (+ x +)
F120_3		nega          		; change sign of 1st value
		ldb	cosv		; get 2nd value (cos)
		bpl	F113_3		; if positive go to different sign
F122_3		negb         		; change sign of 2nd value
		mul          		; multiply them
		bra	F200_3 		; out of smul ( - x -)
F112_3		negb         		; change sign of 2nd value
F113_3		mul          		; multiply them
		nega 			; negate
		negb 			; result
		sbca	#0		; add any carry to the result
F200_3		aslb			; move bit7 regB	
		rola			; to bit0 regA
;**********************************
; y' = x*sin (angle) + y*cos (angle) 
;**********************************
add		adda	#0		; X*sin(angle)+Y*cos(angle)
		sta	y		; save result
		rts			; return


		

;**********************************
;SETUP GFX, CLS ETC
;**********************************
setup2

		ldx 	#$1000
		
		ldd	#$0000
clrlp2		std 	,x++
		cmpx 	#$4800
		blo 	clrlp2



		ldx	#bg
		ldd	#bgend
		ldu	#$1000
		jsr	dunzip
		ldx	#bg
		ldd	#bgend
		ldu	#$3000
		jsr	dunzip




		lda 	#$f0		; pmode 4 /green
		sta 	$ff22		;
		sta 	$ffc3		;
		sta 	$ffc5		;


;**********************************
; CLEAR ALL SAM SCREEN POINTERS 
; THEN SET OFFSET TO $1000
;**********************************
		sta	$ffc6
		sta	$ffc8
		sta	$ffca
		sta	$ffcc
		sta	$ffce
		sta	$ffd0
		sta	$ffd2		
;**********************************
;SET OFFSET TO $1000
;**********************************
		sta	$ffcd
		rts

		

;		align	$100
	
;**********************************
; DRAW LINE
;**********************************
line		opt	cc
;**********************************
; if x0>x1 then swap(x0,y0) & (y0,y1)
;**********************************

		lda 	x0
		cmpa 	x1
		bls 	noswap

		ldb 	x1
		sta 	x1
		stb 	x0
		lda 	y0
		ldb 	y1
		sta 	y1
		stb 	y0
noswap
;**********************************
; calculate start address
;**********************************
scrflip		ldx 	scraddr
		ldd 	x0y0
		lsra
		lsra
		lsra
		leax 	a,x
		lda 	#32
		mul
		leax 	d,x
;**********************************
; get start pixel
;**********************************
		lda 	x0
		anda 	#7
		ldy 	#pixtab
		lda 	a,y
		sta 	pixel+1
		sta	pixel2+1
;**********************************
; dx = (x1-x0)
;**********************************
		lda 	x1
		suba 	x0
		sta 	dx

;**********************************
; dy = abs(y1-y0)
; also determine y increment
;**********************************
		ldb 	#32
		lda 	y1
		suba 	y0
		bpl 	dypos
		nega
		negb
dypos		sta 	dy
;**********************************
; do steep line if (dy > dx)
;**********************************
		cmpa 	dx
		bhi 	steep
;**********************************
; draw shallow line
; (x increments every loop)
;**********************************
		opt	cc		
;**********************************
; setup
;**********************************
		stb 	ystep+2
		ldd 	dxdy
		sta 	dxmod+1
		stb 	dymod+1
		sta 	lcount
;**********************************
; error = dx/2
;**********************************
                ldb 	dx
		lsrb
		
		opt	cc
	
lloop0		lda 	,x
lloop1
pixel		ora 	#0

dymod		subb 	#0		; subb dy
		bpl 	noystep1
dxmod		addb 	#0		; addb dx
		sta	,x
ystep		leax 	<0,x

noystep0	lsr 	pixel+1	; cyclic rotation
		bcc 	nocy0
		ror 	pixel+1
		leax 	1,x
nocy0		dec 	lcount
		bpl 	lloop0		; use bne instead to skip last pixel
		jmp	cloop

noystep1	lsr 	pixel+1	; cyclic rotation
		bcc 	nocy2
		ror 	pixel+1
		sta	,x+
nocy1		dec 	lcount
		bpl 	lloop0		; use bne instead to skip last pixel
		jmp	cloop
	

nocy2		dec 	lcount
		bpl 	lloop1		; use bne instead to skip last pixel
		sta	,x
		jmp	cloop

;**********************************
; draw steep line
; (y increments every loop)
;**********************************

;**********************************
; setup
;**********************************
steep		stb 	noxstep+2
		ldd 	dxdy
		sta 	dxmod2+1
		stb 	dymod2+1
		stb 	lcount
		
;**********************************
; error = dy/2
;**********************************
		lsrb

lloop2
pixel2		lda 	#0
		ora 	,x
		sta 	,x		; draw pixel

dxmod2		subb 	#0		; subb dx
		bpl 	noxstep
dymod2		addb 	#0		; addb dy
		lsr 	pixel2+1
		bcc 	noxstep
		ror 	pixel2+1
		leax 	1,x

noxstep		leax 	<0,x
		dec 	lcount
		bpl 	lloop2		
		jmp	cloop


;***************************************************
; LINE VARS
; all vars inside DP for speed
;***************************************************
x0y0
x0		fcb 	1
y0		fcb 	1
x1y1
x1		fcb 	1
y1		fcb 	1
dxdy
dx		fcb 	1
dy		fcb 	1
lcount		fcb 	1
scraddr		fdb	$3000
;***************************************************
; vector vars
;***************************************************
xp		fcb	0
yp		fcb	0
zp		fcb	0
;***************************************************
; OFFSET VALUES  
;***************************************************
c1		equ	128		;128
c2		equ	96		;96
sinv		fcb	0
cosv		fcb	0
x2		fcb	0
y2		fcb	0
x		fcb	0
y		fcb	0



counter2	fcb	$ff
;***************************************************
; pixel lookup table
;***************************************************

pixtab		fcb 	128,64,32,16,8,4,2,1

;***************************************************
; sin/cos tables 
;
;FOR s = -128 TO 127
;   a1=cint(127 * sin(s * PI / 128)) 
;NEXT 
;***************************************************
	align	$100
;***************************************************
	fcb	0,-3,-6,-9,-12,-16,-19,-22,-25,-28,-31,-34,-37,-40,-43,-46
	fcb	-49,-51,-54,-57,-60,-63,-65,-68,-71,-73,-76,-78,-81,-83,-85,-88
	fcb	-90,-92,-94,-96,-98,-100,-102,-104,-106,-107,-109,-111,-112,-113,-115,-116
	fcb	-117,-118,-120,-121,-122,-122,-123,-124,-125,-125,-126,-126,-126,-127,-127,-128
	fcb	-128,-128,-127,-127,-126,-126,-126,-125,-125,-124,-123,-122,-122,-121,-120,-118
	fcb	-117,-116,-115,-113,-112,-111,-109,-107,-106,-104,-102,-100,-98,-96,-94,-92
	fcb	-90,-88,-85,-83,-81,-78,-76,-73,-71,-68,-65,-63,-60,-57,-54,-51
	fcb	-49,-46,-43,-40,-37,-34,-31,-28,-25,-22,-19,-16,-12,-9,-6,-3
sintab3
	fcb	0,3,6,9,12,16,19,22,25,28,31,34,37,40,43,46
	fcb	49,51,54,57,60,63,65,68,71,73,76,78,81,83,85,88
	fcb	90,92,94,96,98,100,102,104,106,107,109,111,112,113,115,116
	fcb	117,118,120,121,122,122,123,124,125,125,126,126,126,127,127,127
	fcb	127,127,127,127,126,126,126,125,125,124,123,122,122,121,120,118
	fcb	117,116,115,113,112,111,109,107,106,104,102,100,98,96,94,92
	fcb	90,88,85,83,81,78,76,73,71,68,65,63,60,57,54,51
	fcb	49,46,43,40,37,34,31,28,25,22,19,16,12,9,6,3

;***************************************************
; DO THE MATH !
;***************************************************

	fcb	127,127,127,127,126,126,126,125,125,124,123,122,122,121,120,118
	fcb	117,116,115,113,112,111,109,107,106,104,102,100,98,96,94,92
	fcb	90,88,85,83,81,78,76,73,71,68,65,63,60,57,54,51
	fcb	49,46,43,40,37,34,31,28,25,22,19,16,12,9,6,3
	fcb	0,-3,-6,-9,-12,-16,-19,-22,-25,-28,-31,-34,-37,-40,-43,-46
	fcb	-49,-51,-54,-57,-60,-63,-65,-68,-71,-73,-76,-78,-81,-83,-85,-88
	fcb	-90,-92,-94,-96,-98,-100,-102,-104,-106,-107,-109,-111,-112,-113,-115,-116
	fcb	-117,-118,-120,-121,-122,-122,-123,-124,-125,-125,-126,-126,-126,-127,-127,-128
costab3

	fcb	-128,-128,-127,-127,-126,-126,-126,-125,-125,-124,-123,-122,-122,-121,-120,-118
	fcb	-117,-116,-115,-113,-112,-111,-109,-107,-106,-104,-102,-100,-98,-96,-94,-92
	fcb	-90,-88,-85,-83,-81,-78,-76,-73,-71,-68,-65,-63,-60,-57,-54,-51
	fcb	-49,-46,-43,-40,-37,-34,-31,-28,-25,-22,-19,-16,-12,-9,-6,-3
	fcb	0,3,6,9,12,16,19,22,25,28,31,34,37,40,43,46
	fcb	49,51,54,57,60,63,65,68,71,73,76,78,81,83,85,88
	fcb	90,92,94,96,98,100,102,104,106,107,109,111,112,113,115,116
	fcb	117,118,120,121,122,122,123,124,125,125,126,126,126,127,127,127


;***************************************************
; PERSPECTIVE TABLE
;
;FOR s = -128 TO 127
;   a1=cint(127 * (1/s)) 
;NEXT 
;***************************************************

	fcb	29,29,29,29,29,29,29,29,30,30,30,30,30,30,30,30
	fcb	30,30,31,31,31,31,31,31,31,31,31,31,32,32,32,32
	fcb	32,32,32,32,32,33,33,33,33,33,33,33,33,34,34,34
	fcb	34,34,34,34,34,35,35,35,35,35,35,35,35,36,36,36
	fcb	36,36,36,36,37,37,37,37,37,37,37,38,38,38,38,38
	fcb	38,39,39,39,39,39,39,40,40,40,40,40,40,41,41,41
	fcb	41,41,42,42,42,42,42,42,43,43,43,43,43,44,44,44
	fcb	44,45,45,45,45,45,46,46,46,46,47,47,47,47,48,48
ztab	
	fcb	48,48,49,49,49,49,50,50,50,50,51,51,51,51,52,52
	fcb	52,53,53,53,54,54,54,55,55,55,56,56,56,57,57,57
	fcb	58,58,58,59,59,59,60,60,61,61,61,62,62,63,63,64
	fcb	64,64,65,65,66,66,67,67,68,68,69,69,70,70,71,71
	fcb	72,73,73,74,74,75,76,76,77,77,78,79,79,80,81,82
	fcb	82,83,84,85,85,86,87,88,89,89,90,91,92,93,94,95
	fcb	96,97,98,99,100,101,102,104,105,106,107,108,110,111,112,114
	fcb	115,117,118,120,121,123,125,126,127,127,127,127,127,127,127,127




 
;***************************************************
;OBJECT(S) - DONT GO TOO BIG OR BOOM ! 
;
;MAX (ROTATAED SIZE) IS +/- 63
;***************************************************
figure

		fcb 		+32,+32,+32		;0
		fcb 		+32,+32,-32		;32
		fcb 		+32,-32,+32		;2
		fcb 		+32,-32,-32		;32
		fcb 		-32,+32,+32		;4
		fcb 		-32,+32,-32		;32
		fcb 		-32,-32,+32		;6
		fcb 		-32,-32,-32		;7


		fcb		0,0,0


		fcb 		$ff			;end point list	
;***************************************************
; BUFFER FOR ROTATED CENTERED POINTS
;***************************************************
newpoints	fcb		0,0
		fcb		0,0
		fcb		0,0
		fcb		0,0
		fcb		0,0
		fcb		0,0
		fcb		0,0
		fcb		0,0

		fcb		$ff

;***************************************************
; WHICH POINTS TO CONNECT TO DESCRIBE OBJECT
;***************************************************
; OUTER CUBE
;***************************************************
vertfig		fcb		0,1
		fcb		1,3
		fcb		3,2
		fcb		2,0
		fcb		2,6
		fcb		6,4
		fcb		4,5
		fcb		5,1
		fcb		4,0
		fcb		6,7
		fcb		7,5
		fcb		3,7

		fcb		$80			;end line list

**********************************************
* generic unzip X=start/D=end/U=depack address
* big thx to @sixxie for this one + the packer
**********************************************
dunzip		std	f80+1
dunz_loop	ldd	,x++
		bpl	dunz_run	; run of 1-128 bytes
		tstb
		bpl	dunz_7_7
dunz_14_8	lslb			; drop top bit of byte 2
		asra
		rorb			; asrd
		leay	d,u
		ldb	,x+
		bra	f10		; copy 1-256 bytes (0 == 256)
dunz_7_7	leay	a,u		; copy 1-128 bytes
f10		lda	,y+
		sta	,u+
		incb
		bvc	f10		; count UP until B == 128
		bra	f80
f1		ldb	,x+
dunz_run	stb	,u+
		inca
		bvc	f1		; count UP until B == 128
f80		cmpx	#$0000
		blo	dunz_loop
		rts
TV
	orcc	#$50
	lda	#$ff
	tfr	a,dp
	setdp	$ff
	lda	#$f8
	sta	<$22


	ldu	#$8000
reset2	lda	$ff03
	bpl	nxt
	lda	$ff02
	dec	mycount2
	bne	nxt
	jmp	[$fffe]
	
nxt	ldx	#$1000
lp12	addd	,u+
	std	,x
	addd	b,u
	std	2,x
	addd	a,u
	std	4,x
	addd	b,u
	std	6,x
	stb	<$20
	leax	8,x
	cmpx	#$2800
	bne	lp12
	cmpu	#$a800
	blo	stop

	leau	-10239,u
stop	bra	reset2


mycount2	fcb	80	

		fcb	1,2,3,4
bg		includebin		"bgnd.dz"
bgend		equ			*
		fcb	1,2,3,4


;		end	START