***************************************
* SG8 ROTATING ZOOMING CHESSBOARD
* (C)2016 SIMON JONASSEN
*
* ALL CODE IS PUBLIC DOMAIN AND FREE 
* FOR ANY USE YOU SEE FIT....
*
* IF YOU DO USE ANY OF THIS, THEN 
* PLEASE GIVE CREDIT WHERE IT'S DUE
***************************************
		opt	6809	
		opt	cd
;		org	$3c00
;start	
		ldx	#$400
		ldd	#$8080
cls		std	,x++
		cmpx 	#$d00
		blo	cls

		sta	$ffc0		;kill other sg modes
		sta	$ffc2
		sta	$ffc4

		sta	$ffc3		;sg8


		ldx	#$4e0
		ldu	#coco2
h11		ldd	,u++
		std	,x++
		cmpu	#cocoend2
		blo	h11



		ldx	#$a80
		ldu	#loco
h22		ldd	,u++
		std	,x++
		cmpu	#locoend
		blo	h22

			

cosang		macro
		std	ca\1+1
		endm

sinang		macro
		std	sa\1+1
		endm

		ldx	#coltab2

loopie		lda	$ff03
		bpl	abc
		lda	$ff02
		ldy	counter
		leay	-1,y
		sty	counter
		bne	abc

		ldx	#$400
		ldd	#$8080
cls2		std	,x++
		cmpx	#$c00	
		blo	cls2

		jmp	$4800

***************************************
* WORK OUT THE DELTAX/Y
***************************************
abc
		ldu	#MUL16
cosptr		ldb	costab		;(angle in LSB 0..255)
		sex			;extend the sign for 16bit arithmetic
		cosang	1	
		cosang	2
		cosang	3
		cosang	4
		cosang	5
		cosang	6
		cosang	7
		cosang	8
		cosang	9
		cosang	10
		cosang	11
		cosang	12
		cosang	13
		cosang	14
		cosang	15
		cosang	16
		cosang	17
		cosang	18
		cosang	19
		cosang	20
		cosang	21
		cosang	22
		cosang	23
		cosang	24
		cosang	25
		cosang	26
		cosang	27
		cosang	28
		cosang	29
		cosang	30
		cosang	31
		cosang	32

	
		clra	
		aslb
		rola			;*2 for WORD lookup
		ldd	d,u		;got cos 
		
		std	d4+1	

		lsra
		rorb
		std	d1+1	
		

sinptr		ldb	sintab2		;(angle in LSB 0..255)
		sex
		sinang	1
		sinang	2
		sinang	3
		sinang	4
		sinang	5
		sinang	6
		sinang	7
		sinang	8
		sinang	9
		sinang	10
		sinang	11
		sinang	12
		sinang	13
		sinang	14
		sinang	15
		sinang	16
		sinang	17
		sinang	18
		sinang	19
		sinang	20
		sinang	21
		sinang	22
		sinang	23
		sinang	24
		sinang	25
		sinang	26
		sinang	27
		sinang	28
		sinang	29
		sinang	30
		sinang	31
		sinang	32

		clra	
		aslb
		rola			;*2 for WORD lookup		
		ldd	d,u		
		std	d2+1			

		lsra
		rorb

		std	d3+1			

d2		ldd	#0
d1		subd	#0		
		std	yca1+1

		ldd	#0
d3		subd	#0		
d4		subd	#0
		std	ysa1+1

		ldu	#$5c0		;screen start	
***************************************
* YLOOP
***************************************
yloop2		cmpu    #$a40		;screen end
		lbge	out3

ysa1		ldd	#0		ysa		;xrot=ysa
		std	xr1+1
		addd	sa1+1
		std	ysa1+1

yca1		ldd	#0		yca		;yrot=yca
		std	yr1+1
		addd	ca1+1
		std	yca1+1

***************************************
; PLOTTER MACRO
***************************************
plotx		macro	
xr\1		ldd	#0		;xrot
ca\1		addd	#0
		std	xr\2+1
	
yr\1		ldd	#0
sa\1		subd	#0
		std	yr\2+1		;yrot
		adda	xr\1+1
store\1		lda	a,x
plot\1		sta	\1-1,u

		endm
***************************************

***************************************
;xloop
***************************************
		plotx	1,2
		plotx	2,3
		plotx	3,4
		plotx	4,5
		plotx	5,6
		plotx	6,7
		plotx	7,8
		plotx	8,9
		plotx	9,10
		plotx	10,11
		plotx	11,12
		plotx	12,13
		plotx	13,14
		plotx	14,15
		plotx	15,16
		plotx	16,17
		plotx	17,18
		plotx	18,19
		plotx	19,20
		plotx	20,21
		plotx	21,22
		plotx	22,23
		plotx	23,24
		plotx	24,25
		plotx	25,26
		plotx	26,27
		plotx	27,28
		plotx	28,29
		plotx	29,30
		plotx	30,31
		plotx	31,32


xr32		ldd	#0		;xrot
ca32		addd	#0
		std	xr1+1
yr32		ldd	#0
sa32		subd	#0
		std	yr1+1		;yrot
		adda	xr32+1
		lda	a,x
plot32		sta	31,u
		leau	64,u
***************************************
* bottom of yloop
***************************************
		jmp	yloop2
***************************************
* yloop done
***************************************
out3		lda	cosptr+2	;angle=angle+1
		adda	#3
		sta	cosptr+2

		lda	sinptr+2	;angle=angle+3
		adda	#3
		sta	sinptr+2
		jmp	loopie	


		align	$100
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
coltab2
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5
		fcb	$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5,$80,$a5


		align	$100

**********************************************************
* aligned fixed point sin/cos tables 
* with zoom (1.2 is scale)
*
* formula:
*
*  cint(32 * SIN(s * PI / 64) * (COS(s * PI / 64) + 1.2)
*  cint(32 * COS(s * PI / 64) * (COS(s * PI / 64) + 1.2)
**********************************************************

costab	fcb	70,70,70,69,68,67,66,65,63,61,59,56,54,51,49,46
	fcb	43,40,37,34,31,28,25,22,19,17,14,11,9,6,4,2
	fcb	0,-2,-3,-5,-6,-7,-8,-9,-10,-11,-11,-11,-11,-12,-11,-11
	fcb	-11,-11,-11,-10,-10,-9,-9,-9,-8,-8,-7,-7,-7,-7,-7,-6
	fcb	-6,-6,-7,-7,-7,-7,-7,-8,-8,-9,-9,-9,-10,-10,-11,-11
	fcb	-11,-11,-11,-12,-11,-11,-11,-11,-10,-9,-8,-7,-6,-5,-3,-2
	fcb	0,2,4,6,9,11,14,17,19,22,25,28,31,34,37,40
	fcb	43,46,49,51,54,56,59,61,63,65,66,67,68,69,70,70
	fcb	70,70,70,69,68,67,66,65,63,61,59,56,54,51,49,46
	fcb	43,40,37,34,31,28,25,22,19,17,14,11,9,6,4,2
	fcb	0,-2,-3,-5,-6,-7,-8,-9,-10,-11,-11,-11,-11,-12,-11,-11
	fcb	-11,-11,-11,-10,-10,-9,-9,-9,-8,-8,-7,-7,-7,-7,-7,-6
	fcb	-6,-6,-7,-7,-7,-7,-7,-8,-8,-9,-9,-9,-10,-10,-11,-11
	fcb	-11,-11,-11,-12,-11,-11,-11,-11,-10,-9,-8,-7,-6,-5,-3,-2
	fcb	0,2,4,6,9,11,14,17,19,22,25,28,31,34,37,40
	fcb	43,46,49,51,54,56,59,61,63,65,66,67,68,69,70,70

		align	$100

sintab2
	fcb	0,3,7,10,14,17,20,23,26,29,31,34,36,38,40,42
	fcb	43,44,45,46,47,47,47,47,47,46,46,45,44,43,41,40
	fcb	38,37,35,33,32,30,28,26,24,22,21,19,17,16,14,13
	fcb	11,10,9,8,7,6,5,4,3,3,2,2,1,1,1,0
	fcb	0,0,-1,-1,-1,-2,-2,-3,-3,-4,-5,-6,-7,-8,-9,-10
	fcb	-11,-13,-14,-16,-17,-19,-21,-22,-24,-26,-28,-30,-32,-33,-35,-37
	fcb	-38,-40,-41,-43,-44,-45,-46,-46,-47,-47,-47,-47,-47,-46,-45,-44
	fcb	-43,-42,-40,-38,-36,-34,-31,-29,-26,-23,-20,-17,-14,-10,-7,-3
	fcb	0,3,7,10,14,17,20,23,26,29,31,34,36,38,40,42
	fcb	43,44,45,46,47,47,47,47,47,46,46,45,44,43,41,40
	fcb	38,37,35,33,32,30,28,26,24,22,21,19,17,16,14,13
	fcb	11,10,9,8,7,6,5,4,3,3,2,2,1,1,1,0
	fcb	0,0,-1,-1,-1,-2,-2,-3,-3,-4,-5,-6,-7,-8,-9,-10
	fcb	-11,-13,-14,-16,-17,-19,-21,-22,-24,-26,-28,-30,-32,-33,-35,-37
	fcb	-38,-40,-41,-43,-44,-45,-46,-46,-47,-47,-47,-47,-47,-46,-45,-44
	fcb	-43,-42,-40,-38,-36,-34,-31,-29,-26,-23,-20,-17,-14,-10,-7,-3

		align	$100

**********************************************************
* Multiplicaton table as 6809 MUL is unsigned
*
* this also serves as translation from cartesian to
* screen coordinates at the same time
*
* formula:
*
* FOR m = -128 TO 127
*   m16(m)=cint(m * 16) 
* NEXT
*
**********************************************************

MUL16	fdb	-2048,-2032,-2016,-2000,-1984,-1968,-1952,-1936,-1920,-1904,-1888,-1872,-1856,-1840,-1824,-1808
	fdb	-1792,-1776,-1760,-1744,-1728,-1712,-1696,-1680,-1664,-1648,-1632,-1616,-1600,-1584,-1568,-1552
	fdb	-1536,-1520,-1504,-1488,-1472,-1456,-1440,-1424,-1408,-1392,-1376,-1360,-1344,-1328,-1312,-1296
	fdb	-1280,-1264,-1248,-1232,-1216,-1200,-1184,-1168,-1152,-1136,-1120,-1104,-1088,-1072,-1056,-1040
	fdb	-1024,-1008,-992,-976,-960,-944,-928,-912,-896,-880,-864,-848,-832,-816,-800,-784
	fdb	-768,-752,-736,-720,-704,-688,-672,-656,-640,-624,-608,-592,-576,-560,-544,-528
	fdb	-512,-496,-480,-464,-448,-432,-416,-400,-384,-368,-352,-336,-320,-304,-288,-272
	fdb	-256,-240,-224,-208,-192,-176,-160,-144,-128,-112,-96,-80,-64,-48,-32,-16
	fdb	0,16,32,48,64,80,96,112,128,144,160,176,192,208,224,240
	fdb	256,272,288,304,320,336,352,368,384,400,416,432,448,464,480,496
	fdb	512,528,544,560,576,592,608,624,640,656,672,688,704,720,736,752
	fdb	768,784,800,816,832,848,864,880,896,912,928,944,960,976,992,1008
	fdb	1024,1040,1056,1072,1088,1104,1120,1136,1152,1168,1184,1200,1216,1232,1248,1264
	fdb	1280,1296,1312,1328,1344,1360,1376,1392,1408,1424,1440,1456,1472,1488,1504,1520
	fdb	1536,1552,1568,1584,1600,1616,1632,1648,1664,1680,1696,1712,1728,1744,1760,1776
	fdb	1792,1808,1824,1840,1856,1872,1888,1904,1920,1936,1952,1968,1984,2000,2016,2032

***************************************
;DATA
***************************************
counter	fdb	$130

coco2	fcb	$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$c0,$c0,$ca,$c5,$c0,$c5,$ca,$c5,$c0,$c0,$ca,$c5,$c0,$c5,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$ca,$c0,$c0,$c5,$c0,$c0,$ca,$c5,$ca,$c0,$c0,$c5,$c0,$c0,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$ca,$c0,$ca,$c5,$c0,$c0,$ca,$c5,$ca,$c0,$ca,$c5,$c0,$c0,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	fcb	$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0

cocoend2	equ	*
	

loco	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$c0,$c0,$c0,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$c0,$c0,$c0,$c5,$c0,$c5,$ca,$c5,$c0,$c0,$ca,$c5,$c0,$c5,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$ca,$c0,$c0,$c5,$c0,$c0,$ca,$c5,$ca,$c0,$c0,$c5,$c0,$c0,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$ca,$c0,$ca,$c5,$c0,$c0,$ca,$c5,$ca,$c0,$ca,$c5,$c0,$c0,$ca
	fcb	$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c0,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca,$c5,$cf,$cf,$ca
locoend	equ	*





;		end 	start