'**********************************
' VBSCRIPT PBM CONVERTER
' (C) SIMON JONASSEN
' FREE FOR ALL
' REMEMBER WHERE IT CAME FROM
'**********************************


Function BinToDec(strBin)
  dim lngResult
  dim intIndex

  lngResult = 0
  for intIndex = len(strBin) to 1 step -1
    strDigit = mid(strBin, intIndex, 1)
    select case strDigit
      case "0"
        ' do nothing
      case "1"
        lngResult = lngResult + (2 ^ (len(strBin)-intIndex))
      case else
        ' invalid binary digit, so the whole thing is invalid
        lngResult = 0
        intIndex = 0 ' stop the loop
    end select
  next

  BinToDec = lngResult
End Function


set fs=createobject("Scripting.filesystemobject")
set f=fs.opentextfile("bgnd.pbm")
set f2=fs.createtextfile("bgnd.bin")
set f3=fs.createtextfile("bgnd.raw")
f.readline
f.readline
xy=f.readline
xy=replace(xy,chr(32),",")
x=left(xy,instr(xy,",")-1)
y=mid(xy,instr(xy,",")+1)
x=cint(x)
y=cint(y)


do while not f.atendofstream
  block=block & f.read(1)
loop

block=replace(block,chr(32),"")
block=replace(block,chr(10),"")
f2.write(block)

f2.close
set f2=fs.opentextfile("bgnd.bin")


for i=0 to y-1
  line=f2.read(x)
  f3.writeline(line)	 
next
f2.close
f3.close


set f3=fs.opentextfile("bgnd.raw")
set f2=fs.createtextfile("bgnd.fcb")
REM f2.writeline ("x" &chr(9) & "fdb" & chr(9) & x)
REM f2.writeline ("y" &chr(9) & "fdb" & chr(9) & y)
f2.write("img")

for j=0 to y-1
  mybyte=""

  for i=0 to (x / 8) - 1
   thebyte=f3.read(8)
   thebyte=  BinToDec(thebyte) 
   mybyte= mybyte & thebyte & ","
  next

  mybyte= chr(9) & "fcb" & chr(9) & left(mybyte,len(mybyte)-1)

  f3.read(2)
  f2.writeline(mybyte)
next

f2.close()
f3.close()
fs.deletefile ("bgnd.raw")
fs.deletefile ("bgnd.bin")

set f=nothing
set fs=nothing
